// SuperTelnet.java : An application by Rohit Singh to Telnet outside the confines of IIT Kgp
// Resistance is Futile; Firewalls doubly so... Java is Coffee ;)
//
// Version 1.0 : Released on 27th March 1999
// Version 1.1 : date 28th March 1999 ; Removed the message which came from the
// 				        Proxy Server in case of Time-out's and Unknown Hosts
// Version 1.2 : date 31st March 1999 ; Made it more "well behaved" ; sends TERM info("vt100");
//					Does not BLINDLY refuse DO and WILL requests.
//
/////////////////////////////////////////////////////////////////////////////////////////////


import java.lang.*;
import java.net.*;
import java.io.*;

public class st {
	
  public static void main(String args[]) {
    PortTalk portTalker = new PortTalk(args);
    portTalker.start();
  }
}

class PortTalk extends Thread {
  Socket connection;
  OutputStream outStream;
  NVTInputStream inStream;
  NVTPrinter printer;
  PrintWriter PROut;

  public PortTalk(String args[]) {
    if ((args.length > 2)||(args.length < 1)) error("Usage: java telapp <host> <OPTIONAL:port>");
    String destination = args[0];
    int port = 23;  // Using Well Known Telnet Port
    if (args.length == 2) port = Integer.parseInt(args[1]);
    System.out.println("SuperTelnet (c) Rohit Singh 1999");
    System.out.println("WARNING: Everything, including your dear old crazy Password will be ECHOED");
    System.out.println("Send $ 25 to the author to disable this feature ;={) \n");
    
    try {
//I've hardcoded IITKGP's Squid Proxy Servers IP address here
//It can be changed to your own Proxy Server(I've tested it only on Squid though)
	connection = new Socket("144.16.192.213", 8080);
    } catch (UnknownHostException e) { error("Unknown Host... why don't you try IP address instead ?"); }
    catch (IOException e) { error("IO error creating socket");  }
		

    try {
	outStream = connection.getOutputStream();
	inStream  = new NVTInputStream(connection.getInputStream(), outStream);
	boolean is_first_byte = true;
	
	} catch (IOException e) { error("IO error getting streams"); }
    

    // Connecting to Proxy

    PROut = new PrintWriter(new OutputStreamWriter(outStream));
	PROut.println("POST http://" + destination + ":" + port + " CRLF");
	PROut.println();
	PROut.flush();
	System.out.println("Trying " + destination + " at port " + port + ".");
  }

  public void run() {
    printer = new NVTPrinter(inStream);
    printer.start();
    yield();
    processUserInput();
    shutdown();
  }

  public void processUserInput() {
    try {
      String line;
      boolean finished = false;
      BufferedReader userInputStream = new BufferedReader(new InputStreamReader (System.in));

      do {
        line = userInputStream.readLine();
        if (line == null) finished = true;
        else {
          try {
            for (int i=0; i < line.length(); ++i)
              outStream.write(line.charAt(i));
            outStream.write('\n');
          } catch (IOException e) { error("IO Error writing to Stream"); }
        }
      } while (!finished);
    } catch (IOException e) { error("Error reading user input"); }
  }
 

  public void shutdown() {
    try {
      connection.close();
    } catch (IOException e) { error("IO error closing socket"); }
  }

  public void error(String s) {
    System.out.println(s);
    System.exit(1);
  }


	public class NVTPrinter extends Thread {

	NVTInputStream inStream;

		public NVTPrinter(NVTInputStream in) {
			super();
			inStream = in;
		}

		public void run() {
		boolean finished = false;
			try {
				do {
					int i = inStream.read();
					if (i == -1) finished = true;
					else {
						System.out.print((char) i);
						System.out.flush();
						yield();
					}
				} while (!finished);
				System.out.println("\nConnection closed.");
				System.exit(0);
			} catch (IOException e) {
 				System.out.println("NVTPrinter error");
				System.exit(1);
			}
		}
}


public class NVTInputStream extends FilterInputStream {
	byte IAC = (byte) 0xff;
	byte DO  = (byte) 0xfd;
	byte WILL= (byte) 0xfb;
	byte CR  = 13;
	byte LF  = 10;
	int WONT = 252;
	int DONT = 254;
	int BUFFER_SIZE = 1024;
	OutputStream out;
	byte lineBuffer[] = new byte[BUFFER_SIZE];
	int numBytes = 0;
	boolean is_first_byte = true;
	int firstbyteread;
	
	public NVTInputStream(InputStream inStream, OutputStream outStream) {
		super(inStream);
		is_first_byte = true;
		out = outStream;
	}


   void transmit(String str)
     {
     int i;

     for(i=0; i<str.length(); i++)
       transmitch(str.charAt(i));
     }

   void transmitch(char c)
     {
     if (c == '\n') transmitch('\r');
     try {
       out.write((int)c);
       out.flush();
       }
     catch(IOException e) {};
   
     //System.out.println("Sent char " + String.valueOf((int)c) + " = " + String.valueOf(c));
     }
	

	public int read() throws IOException {
		boolean recIAC;
		int i;
                int firstbyteread=255;

		
		do {
			recIAC = false;
			if (is_first_byte) {
                                 //is_first_byte=false;
                                firstbyteread = in.read();
                                System.out.println("First byte Read = " + firstbyteread);
                                if (firstbyteread == 72) { 
                                        System.out.println("Oops... ! Cant find your Host :(... try IP Address!");
                                        System.exit(1);
                                        } else {
                                        System.out.println("Connected !!! ");
                                 }
                        }
		
			if (is_first_byte) {
				i = firstbyteread;
				System.out.println("First byte: " + firstbyteread + " ; i= " + i);
				is_first_byte= false; 
			} else {
				i = in.read();
			}
		
			//System.out.println("Recieved int: " + i);
			//System.in.read();
			if (i == -1) return i;
			byte b = (byte) i;
			if (b == IAC) {
				//System.out.println("IAC recieved");
				recIAC = true;
				int cmd = in.read();
				if (cmd == -1) return cmd;
				byte b2 = (byte) cmd;
				if (b2 == IAC) return 255;
				int opt = in.read();
				//System.out.println("opt= " + opt);



       switch(opt) {
         case 1:  // echo
            if (cmd == 251)
              {
              transmitch((char)255);
              transmitch((char)253);
              transmitch((char)1);
              //echo = false;
              }
            else if (cmd == 252)
              {
              transmitch((char)255);
              transmitch((char)254);
              transmitch((char)1);
              //echo = true;
              }
            else if (cmd == 253)
              {
              transmitch((char)255);
              transmitch((char)251);
              transmitch((char)1);
              }

            break;

         case 3: // supress go-ahead
            transmitch((char)255);
            transmitch((char)253);
            transmitch((char)opt);
            break;

         case 35: // X display location
            transmitch((char)255);
            transmitch((char)252);
            transmitch((char)35);
            break;

         case 33: // Remote Flow control
            transmitch((char)255);
            transmitch((char)252);
            transmitch((char)33);
            break;


         case 39:
            transmitch((char)255);
            transmitch((char)252);
            transmitch((char)39);
            break;

         case 36: // Environment option
            transmitch((char)255);
            transmitch((char)252);
            transmitch((char)36);
            break;

         case 24: // terminal type
            if (cmd == 253) {
              // IAC WILL terminal-type
              transmitch((char)255);
              transmitch((char)251);
              transmitch((char)24);
					}
            else if (cmd == 250) {
              // IAC SB terminal-type IS <term> IAC SE
              transmitch((char)255);
              transmitch((char)250);
              transmitch((char)24);
              transmitch((char)0);
              
                transmit("vt100"); //transmit method to be defined
              
              transmitch((char)255);
              transmitch((char)240);
              }
            break;

/*        case 37: // Authentication
            if (cmd == 253) {
              // IAC WILL terminal-type
              transmitch((char)255);
              transmitch((char)251);
              transmitch((char)37);

              // IAC SB 0000 IAC SE
              transmitch((char)255);
              transmitch((char)250);
              transmitch((char)37);
              transmitch((char)0);
              transmitch((char)0);
              transmitch((char)0);
              transmitch((char)0);
              transmitch((char)255);
              transmitch((char)240);
              }
            break;
*/
         default: //
			if (b2 == DO) { 
					
					//System.out.println("DO opt= " + opt + " recieved.");
					if (opt == -1) return opt;					
					out.write(255);
					out.write(WONT);
					out.write(opt);
					out.write('\n');
					out.flush();
					//System.out.println("Sent 255 WONT " + opt);
					//System.in.read();

				} else if (b2 == WILL) {
					//System.out.println("WILL opt= " + opt + " recieved.");
					if (opt == -1) return opt;
					out.write(255);
					out.write(DONT);
					out.write(opt);
					out.write('\n');
					out.flush();
					//System.out.println("Sent 255 DONT " + opt);
					//System.in.read();
				}
			break;
         }





			}
		} while (recIAC);
		return i;
	}
}
}

